import datetime
from _typeshed import Incomplete
from airflow.configuration import conf as conf
from airflow.utils import timezone as timezone

class SecretCache:
    class NotPresentException(Exception): ...
    class _CacheValue:
        value: Incomplete
        date: Incomplete
        def __init__(self, value: str | None) -> None: ...
        def is_expired(self, ttl: datetime.timedelta) -> bool: ...
    @classmethod
    def init(cls) -> None: ...
    @classmethod
    def reset(cls) -> None: ...
    @classmethod
    def get_variable(cls, key: str) -> str | None: ...
    @classmethod
    def get_connection_uri(cls, conn_id: str) -> str: ...
    @classmethod
    def save_variable(cls, key: str, value: str | None): ...
    @classmethod
    def save_connection_uri(cls, conn_id: str, uri: str): ...
    @classmethod
    def invalidate_variable(cls, key: str): ...
